#ifndef FLOAT_TO_STR_H
#define FLOAT_TO_STR_H
#include <stdint.h>
#include <stdlib.h>

#ifdef __cplusplus
extern "C" {
#endif //__cplusplus
  /**
   * @author <mrazik@volny.cz>
   *         licence : <a href="https://cs.wikipedia.org/wiki/Licence_MIT">MIT</a>
   * 
   * @function float_to_str
   * @brief Funkce převádí float (single, 32 bit) na c-string ve formátu zhruba "+.7E"
   *        Velmi zjednodušená, nezaokrouhluje.
   *
   * @param buf char buffer o minimální délce 16 bytů (není kontrolováno)
   * @param f float vstup (předpoklad je formát podle IEEE 754 v little endien)
   * @return počet zapsaných bytů (mimo ukončovací 0)
   * */
  extern size_t float_to_str (char * buf, const float f);
#ifdef __cplusplus
};
#endif //__cplusplus

#endif // FLOAT_TO_STR_H
