#include <stdio.h>
#include <math.h>
#include <time.h>
#include "float_to_str.h"

static void test1 () {
  const size_t max = 16u;
  char buf [max];
  char fmt [max];
  char dif [2*max];
  float_to_str(buf, 0.0f);
  printf ("zero test = %s\n", buf);
  for (unsigned n=0; n<20; n++) {
    const float a = - (float) n; // zmenou +/- testujeme velka i mala cisla
    const float f = expf (a);
    size_t r = float_to_str (buf, f);
    size_t l = snprintf (fmt, max, "%+.7E", f);
    unsigned i = 0, k = 0;
    for (i=0; i<r; i++) {
      if (fmt[i] == buf[i]) dif [k] = '-';
      else                  dif [k] = fmt [i];
      k += 1;
    }
    for (i=0; i<r; i++) {
      if (fmt[i] == buf[i]) dif [k] = ' ';
      else                  dif [k] = buf [i];
      k += 1;
    }
    dif [k] = '\0';
    printf ("a=%+3g, exp(a) -> %zd:\"%s\" <=> %zd:\"%s\" diff=\"%s\"\n", a, l, fmt, r, buf, dif);
  }
}
static void test2 () {
  // return;
  union fu {
    uint32_t u;
    float    f;
  } x;
  const size_t max = 16u;
  char buf [max];
  time_t t;
  srandom (time(&t));
  // o něco větší chyby se už projeví - není řešeno zaokrouhlování
  const double ppm = 0.33;
  printf("random test for relative error %g ppm ...\n", ppm);
  unsigned k = 0u, ne = 0u;
  double sum = 0.0;
  for (unsigned n=0; n<10000000; n++) {
    uint32_t r = random ();
    x.u = r;
    if (fpclassify((double)x.f) != FP_NORMAL) {
      // printf ("strange number: %08X (%e)\n", x.u, (double)x.f);
      continue;
    }
    const size_t ll = float_to_str (buf, x.f);
    (void) ll;
    // if (ll != 14) printf ("? -> %s\n", buf);
    const double z = atof (buf);
    const double d = x.f;
    if (d == 0.0 or z == 0.0) continue;
    k += 1u;
    const double e = fabs (1.0e6 * (d - z) / d);
    sum += e;
    if (e > ppm) {
      printf ("%+.7E != %+.7E err=%.8e ppm\n", z, d, e);
      ne += 1u;
    }
  }
  const double cer = sum / (double) k;
  printf ("%d normal numbers tested, %d errors, average relative error = %e ppm\n", k, ne, cer);
}
/* Nezdá se, že by v tom byly fatální chyby */
int main () {
  test1();
  test2();
  return 0;
}
